`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/30 15:17:24
// Design Name: 
// Module Name: display_decoder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module display_decoder(
    input clk,
    input rst,
    inout PS2_DATA,
    inout PS2_CLK,
    output reg [7:0] segs,
    output reg [3:0] ssd_ctl
    );
    reg [8:0] number;
    wire [511:0] key_down;
    wire [8:0] last_change;
    wire key_valid;
        
    KeyboardDecoder U0(.clk(clk),.rst(rst),.PS2_DATA(PS2_DATA),.PS2_CLK(PS2_CLK)
                        ,.key_down(key_down),.last_change(last_change),.key_valid(key_valid));
    
    always@*
    if(last_change == 9'h5A)
        ssd_ctl = 4'b1111;
    else
        ssd_ctl = 4'b1110;
    
    always@*
    if(key_valid)
        number = last_change;
    else
        number = number;
    
    always@*
        case(number)
            9'h70: segs = 8'b0000_0011;
            9'h69: segs = 8'b1001_1111;
            9'h72: segs = 8'b0010_0101;
            9'h7A: segs = 8'b0000_1101;
            9'h6B: segs = 8'b1001_1001;
            9'h73: segs = 8'b0100_1001;
            9'h74: segs = 8'b0100_0001;
            9'h6C: segs = 8'b0001_1111;
            9'h75: segs = 8'b0000_0001;
            9'h7D: segs = 8'b0000_1001;
            9'h1C: segs = 8'b0001_0001;
            9'h1B: segs = 8'b1111_1101;
            9'h3A: segs = 8'b1001_0001;
            default: segs = 8'b0111_0001;
        endcase
        
endmodule
